# class XmlElementOut | An outgoing XML element. More...
Full name | `TelEngine::XmlElementOut`
Definition | `#include <libs/yjabber/xmpputils.h>`
Inherits | TelEngine::RefObject [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- inline XmlElementOut (XmlElement* element, const char* senderID = 0, bool unclose = false)
- virtual ~XmlElementOut ()
- inline XmlElement* element () const
- inline bool sent () const
- inline const String& buffer ()
- inline const String& id () const
- inline unsigned int dataCount ()
- inline const char* getData (unsigned int& nCount)
- inline void dataSent (unsigned int nCount)
- inline XmlElement* release ()
- inline void toBuffer (String& buffer)
- inline void prepareToSend ()

## Detailed Description

This class holds an XML element to be sent through a stream

inline XmlElementOut (XmlElement* element, const char* senderID = 0, bool unclose = false) | ### XmlElementOut

Constructor

Parameters:

element | The XML element
senderID | Optional sender id
unclose | True to not close the tag when building the buffer

~XmlElementOut () | ### ~XmlElementOut

[virtual]

Destructor Delete m_element if not 0

inline XmlElement* element () | ### element

[const]

Get the underlying element

Returns: The underlying element

inline bool sent () | ### sent

[const]

Check if this element was (partially) sent

Returns: True if an attempt to send this element was already done

inline const String& buffer () | ### buffer

Get the data buffer

Returns: The data buffer

inline const String& id () | ### id

[const]

Get the id member

Returns: The id member

inline unsigned int dataCount () | ### dataCount

Get the remainig byte count to send

Returns: The unsent number of bytes

inline const char* getData (unsigned int& nCount) | ### getData

Get the remainig data to send. Set the buffer if not already set

Parameters:

nCount | The number of unsent bytes

Returns: Pointer to the remaining data or 0

inline void dataSent (unsigned int nCount) | ### dataSent

Increase the offset with nCount bytes. Set the sent flag

Parameters:

nCount | The number of bytes sent

inline XmlElement* release () | ### release

Release the ownership of m_element The caller is responsable of returned pointer

Returns: XmlElement pointer or 0

inline void toBuffer (String& buffer) | ### toBuffer

Fill a buffer with the XML element to send

Parameters:

buffer | The buffer to fill

inline void prepareToSend () | ### prepareToSend

Fill the buffer with the XML element to send

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.